local slowmo = {}
slowmo.scale = 100
slowmo.slow = false
slowmo.active = "Inactive"
slowmo.hide = false
slowmo.cd = 0
slowmo.menuOpened = false
slowmo.awaitInput = false
slowmo.selectedButton = nil
slowmo.inputIdentifier = nil
slowmo.cfgpath = os.getenv('APPDATA').."\\SlowMoMod\\cfg\\"
slowmo.cfgfile = slowmo.cfgpath.."config.cfg"

slowmo.keySlow = Keys.Add
slowmo.keyFast = Keys.Subtract
slowmo.keyToggle = Keys.J
slowmo.keyInterface = Keys.F5
slowmo.keyMenu = Keys.O
slowmo.step = 5
slowmo.stdcd = 5

slowmo.player = PLAYER.PLAYER_ID()

slowmo.version = "0.3.4"

slowmo.GUI = Libs["slowmoGUI"]

function slowmo.unload()
	GAMEPLAY.SET_TIME_SCALE(1)
end

function slowmo.init()
	print("-------------------------------\nSlowModMod by CaptainProton42\nVersion 0.3.4\n-------------------------------")
	if not fileExists(slowmo.cfgfile) then
		slowmo.createCfg()
	end

	slowmo.readCfg()
	
	slowmo.cfgUpdate()
	
	slowmo.GUI.addButton("Toggle Slowmo: "..slowmo.GUI.keyName[slowmo.keyToggle], slowmo.chooseKey, "Key.Toggle")
	slowmo.GUI.addButton("Slow Down: "..slowmo.GUI.keyName[slowmo.keySlow], slowmo.chooseKey, "Key.Slow")
	slowmo.GUI.addButton("Faster: "..slowmo.GUI.keyName[slowmo.keyFast], slowmo.chooseKey, "Key.Fast")
	slowmo.GUI.addButton("Toggle Indicator: "..slowmo.GUI.keyName[slowmo.keyInterface], slowmo.chooseKey, "Key.Interface")
	slowmo.GUI.addButton("Toggle Menu "..slowmo.GUI.keyName[slowmo.keyMenu], slowmo.chooseKey, "Key.Menu")
	slowmo.GUI.addButton("Slowmo Step: "..slowmo.step, nil, nil)
	slowmo.GUI.addButton("Key Sensitivity: "..slowmo.stdcd, nil, nil)	
end

function slowmo.cfgUpdate()
	local i = 0
	for line in io.lines(slowmo.cfgfile) do
		i = i + 1
		if string.find(line,"for SlowMoMod") ~= nil then
			if string.sub(line,string.find(line,"Mod")+4,-1)~= version then
				file = assert(io.open(slowmo.cfgfile, "w"))
				file:write()
				file:close()
				for line in io.lines("scripts\\slowmo_files\\config.cfg") do
					file = assert(io.open(slowmo.cfgfile, "a"))
					file:write(line)
					file:write("\n")
					file:close()
					file = assert(io.open("scripts\\slowmo_files\\config.cfg", "r"))
				end
				file:close()
				slowmo.writeToCfg("Key.Toggle", slowmo.keyToggle)
				slowmo.writeToCfg("Key.Slow", slowmo.keySlow)
				slowmo.writeToCfg("Key.Fast", slowmo.keyFast)
				slowmo.writeToCfg("Key.Interface", slowmo.keyInterface)
				slowmo.writeToCfg("Key.Menu", slowmo.keyMenu)
				slowmo.writeToCfg("Slowmo.Step", slowmo.step)
				slowmo.writeToCfg("Slowmo.KeyCD", slowmo.stdcd)
			end
		end
	end	
end

function slowmo.readCfg()
	local i = 0
	for line in io.lines(slowmo.cfgfile) do
		i = i + 1
		if string.find(line,"Key.Interface") ~= nil then
			slowmo.keyInterface=tonumber(string.sub(line,string.find(line,":")+1,-1))
		elseif string.find(line,"Key.Toggle") ~= nil then
			slowmo.keyToggle=tonumber(string.sub(line,string.find(line,":")+1,-1))
		elseif string.find(line,"Key.Slow") ~= nil then
			slowmo.keySlow=tonumber(string.sub(line,string.find(line,":")+1,-1))
		elseif string.find(line,"Key.Fast") ~= nil then
			slowmo.keyFast=tonumber(string.sub(line,string.find(line,":")+1,-1))
		elseif string.find(line,"Key.Menu") ~= nil then
			slowmo.keyMenu=tonumber(string.sub(line,string.find(line,":")+1,-1))
		elseif string.find(line,"Slowmo.Step") ~= nil then
			slowmo.step=tonumber(string.sub(line,string.find(line,":")+1,-1))
		elseif string.find(line,"Slowmo.KeyCD") ~= nil then
			slowmo.stdcd=tonumber(string.sub(line,string.find(line,":")+1,-1))
		end
	end
end

function slowmo.writeToCfg(identifier, value)
	local cfgTable = {}
	i = 1
	file = assert(io.open(slowmo.cfgfile, "r"))
	for line in io.lines(slowmo.cfgfile) do
		cfgTable[i] = line
		i = i + 1
	end
	file:close()
	file = assert(io.open(slowmo.cfgfile, "w"))
	for k = 1, i-1, 1 do
		if cfgTable[k] ~= nil then
			if string.find(cfgTable[k], identifier) ~= nil then
				file:write(identifier..":"..value)
			else
				file:write(cfgTable[k])
			end
		end
		file:write("\n")
	end
	file:close()
end

function slowmo.chooseKey(identifier)
	if identifier == "Key.Toggle" then
		slowmo.GUI.editButton(slowmo.GUI.selection, "Toggle Slowmo: ><", nil, nil)
	elseif identifier == "Key.Slow" then
		slowmo.GUI.editButton(slowmo.GUI.selection, "Slow Down: ><", nil, nil)
	elseif identifier == "Key.Fast" then
		slowmo.GUI.editButton(slowmo.GUI.selection, "Faster: ><", nil, nil)
	elseif identifier == "Key.Interface" then
		slowmo.GUI.editButton(slowmo.GUI.selection, "Toggle Indicator: ><", nil, nil)
	elseif identifier == "Key.Menu" then
		slowmo.GUI.editButton(slowmo.GUI.selection, "Toggle Menu: ><", nil, nil)
	end
	slowmo.awaitInput = true
	slowmo.inputIdentifier = identifier
	slowmo.selectedButton = slowmo.GUI.selection
end

function fileExists(name)
	local f=io.open(name,"r")
	if f~=nil then
		io.close(f)
		return true 
	else 
		return false
	end
end

function slowmo.createCfg()
	os.execute("mkdir "..slowmo.cfgpath)
	file = assert(io.open("scripts\\slowmo_files\\config.cfg", "r"))
	for line in io.lines("scripts\\slowmo_files\\config.cfg") do
		file = assert(io.open(slowmo.cfgfile, "a"))
		file:write(line)
		file:write("\n")
		file:close()
		file = assert(io.open("scripts\\slowmo_files\\config.cfg", "r"))
	end
	file:close()
end

function slowmo.tick()
	slowmo.drawGUI()
	slowmo.cd = slowmo.cd - 1
	if not slowmo.awaitInput then
		if (get_key_pressed(slowmo.keyToggle)) and slowmo.cd < 1 then
			slowmo.cd = slowmo.stdcd
			if not slowmo.slow then
				slowmo.run()
				slowmo.slow = true
				slowmo.active = "Active"
			else
				slowmo.unload()
				slowmo.slow = false
				slowmo.active = "Inactive"
			end
		elseif (get_key_pressed(slowmo.keySlow)) and slowmo.cd < 1 then
			slowmo.cd = slowmo.stdcd
			slowmo.scale = slowmo.scale - slowmo.step;
			if slowmo.scale < 0 then
				slowmo.scale = 0
			end
			if slowmo.slow then
				slowmo.run()
			end
		elseif (get_key_pressed(slowmo.keyFast)) and slowmo.cd < 1 then
			slowmo.cd = slowmo.stdcd
			slowmo.scale = slowmo.scale + slowmo.step;
			if slowmo.scale > 100 then
				slowmo.scale = 100
			end
			if slowmo.slow then
				slowmo.run()
			end
		elseif (get_key_pressed(slowmo.keyInterface)) and slowmo.cd < 1 then
			slowmo.cd = slowmo.stdcd
			if not slowmo.hide then
				slowmo.hide = true
				AUDIO.PLAY_SOUND_FRONTEND(-1, "SOUND_SHOP_BUY_DENIED", "HUD_FRONTEND_DEFAULT_SOUNDSET",1);
			else
				slowmo.hide = false
			end
		elseif (get_key_pressed(slowmo.keyMenu)) and slowmo.cd < 1 then
			if not slowmo.menuOpened then
				slowmo.menuOpened = true
				AUDIO.PLAY_SOUND_FRONTEND(-1, "SELECT", "HUD_FRONTEND_DEFAULT_SOUNDSET", 1);
			else
				slowmo.menuOpened = false
				AUDIO.PLAY_SOUND_FRONTEND(-1, "CANCEL", "HUD_FRONTEND_DEFAULT_SOUNDSET", 1);
			end
			slowmo.cd = slowmo.stdcd
		end
	end		
	
	if slowmo.menuOpened then
		slowmo.GUI.tick(r, g, b, a, slowmo.scale, slowmo.active)
		if string.find(slowmo.GUI.BUTTONS[slowmo.GUI.selection].title,"Slowmo Step: ") then
			if (get_key_pressed(Keys.NumPad6)) and slowmo.cd < 1 and slowmo.step < 100 then
				slowmo.step = slowmo.step + 1
				slowmo.cd = 2
				slowmo.writeToCfg("Slowmo.Step", slowmo.step)
				AUDIO.PLAY_SOUND_FRONTEND(-1, "NAV_LEFT_RIGHT", "HUD_FRONTEND_DEFAULT_SOUNDSET", 1);
			elseif (get_key_pressed(Keys.NumPad4)) and slowmo.cd < 1 and slowmo.step > 1 then
				slowmo.step = slowmo.step - 1
				slowmo.cd = 2
				slowmo.writeToCfg("Slowmo.Step", slowmo.step)
				AUDIO.PLAY_SOUND_FRONTEND(-1, "NAV_LEFT_RIGHT", "HUD_FRONTEND_DEFAULT_SOUNDSET", 1);
			end
			slowmo.GUI.editButton(slowmo.GUI.selection, "Slowmo Step: "..slowmo.step, nil, nil)
		elseif string.find(slowmo.GUI.BUTTONS[slowmo.GUI.selection].title,"Key Sensitivity: ") then
			if (get_key_pressed(Keys.NumPad6)) and slowmo.cd < 1 and slowmo.stdcd < 20 then
				slowmo.stdcd = slowmo.stdcd + 1
				slowmo.cd = 2
				slowmo.writeToCfg("Slowmo.KeyCD", slowmo.stdcd)
				AUDIO.PLAY_SOUND_FRONTEND(-1, "NAV_LEFT_RIGHT", "HUD_FRONTEND_DEFAULT_SOUNDSET", 1);			
			elseif (get_key_pressed(Keys.NumPad4)) and slowmo.cd < 1 and slowmo.stdcd > 0 then
				slowmo.stdcd = slowmo.stdcd - 1
				slowmo.cd = 2
				slowmo.writeToCfg("Slowmo.KeyCD", slowmo.stdcd)
				AUDIO.PLAY_SOUND_FRONTEND(-1, "NAV_LEFT_RIGHT", "HUD_FRONTEND_DEFAULT_SOUNDSET", 1);
			end
			slowmo.GUI.editButton(slowmo.GUI.selection, "Key Sensitivity: "..slowmo.stdcd, nil, nil)
		end
	end
	
	if slowmo.awaitInput then
		for i = 0, 254, 1 do
			if (get_key_pressed(i)) and not (get_key_pressed(Keys.Return)) then
				AUDIO.PLAY_SOUND_FRONTEND(-1, "SELECT", "HUD_FRONTEND_DEFAULT_SOUNDSET", 1);
				if slowmo.inputIdentifier == "Key.Toggle" then
					slowmo.GUI.editButton(slowmo.selectedButton, "Toggle Slowmo: "..slowmo.GUI.keyName[i], slowmo.chooseKey, "Key.Toggle")
					slowmo.keyToggle = i
				elseif slowmo.inputIdentifier == "Key.Slow" then
					slowmo.GUI.editButton(slowmo.selectedButton, "Slow Down: "..slowmo.GUI.keyName[i], slowmo.chooseKey, "Key.Slow")
					slowmo.keySlow = i
				elseif slowmo.inputIdentifier == "Key.Fast" then
					slowmo.GUI.editButton(slowmo.selectedButton, "Faster: "..slowmo.GUI.keyName[i], slowmo.chooseKey, "Key.Fast")
					slowmo.keyFast = i
				elseif slowmo.inputIdentifier == "Key.Interface" then
					slowmo.GUI.editButton(slowmo.selectedButton, "Toggle Indicator: "..slowmo.GUI.keyName[i], slowmo.chooseKey, "Key.Interface")
					slowmo.keyInterface = i
				elseif slowmo.inputIdentifier == "Key.Menu" then
					slowmo.GUI.editButton(slowmo.selectedButton, "Toggle Menu: "..slowmo.GUI.keyName[i], slowmo.chooseKey, "Key.Menu")
					slowmo.keyMenu = i
				end
				slowmo.writeToCfg(slowmo.inputIdentifier, i)
				slowmo.awaitInput = false
			end	
		end
	end
end

function slowmo.run()
	GAMEPLAY.SET_TIME_SCALE(slowmo.scale / 100)
end

function  slowmo.drawGUI()
	if not slowmo.hide then
		if slowmo.scale > 5 then
			r = 255
			g = 255
			b = 255
			a = 255
		elseif slowmo.scale > 0 then
			r = 255
			g = 255
			b = 0
			a = 255
		else
			r = 255
			g = 0
			b = 0
			a = 255
		end
		
		if not slowmo.menuOpened then
			slowmo.GUI.drawIndicator(r, g, b, a, slowmo.scale, slowmo.active)
		end
	end
end

return slowmo